Index: /LMDZ5/trunk/arch/arch-X64_ADA.fcm
===================================================================
--- /LMDZ5/trunk/arch/arch-X64_ADA.fcm	(revision 2269)
+++ /LMDZ5/trunk/arch/arch-X64_ADA.fcm	(revision 2270)
@@ -5,5 +5,5 @@
 %FPP_FLAGS           -P -traditional -I/smplocal/pub/FFTW/3.3.3_dyn/include/
 %FPP_DEF             NC_DOUBLE FFT_FFTW
-%BASE_FFLAGS         -auto -mcmodel=large -integer-size 32 -real-size 64 -align all 
+%BASE_FFLAGS         -auto -recursive -mcmodel=large -integer-size 32 -real-size 64 -align all 
 %PROD_FFLAGS         -O2 -ip -fp-model strict -axAVX,SSE4.2
 %DEV_FFLAGS          -p -g -O1 -fpe0 -traceback
Index: /LMDZ5/trunk/arch/arch-X64_CURIE.fcm
===================================================================
--- /LMDZ5/trunk/arch/arch-X64_CURIE.fcm	(revision 2269)
+++ /LMDZ5/trunk/arch/arch-X64_CURIE.fcm	(revision 2270)
@@ -5,5 +5,5 @@
 %FPP_FLAGS           -P -traditional
 %FPP_DEF             NC_DOUBLE FFT_MKL
-#%BASE_FFLAGS         -xHost -i4 -r8 -auto -align all -I$(MKL_INC_DIR) -I$(MKL_INC_DIR)/intel64/lp64
+#%BASE_FFLAGS        -recursive -xHost -i4 -r8 -auto -align all -I$(MKL_INC_DIR) -I$(MKL_INC_DIR)/intel64/lp64
 %BASE_FFLAGS         -i4 -r8 -auto -align all -I$(MKL_INC_DIR) -I$(MKL_INC_DIR)/intel64/lp64 -fp-model strict
 %PROD_FFLAGS         -O2
Index: /LMDZ5/trunk/arch/arch-gfortran.fcm
===================================================================
--- /LMDZ5/trunk/arch/arch-gfortran.fcm	(revision 2269)
+++ /LMDZ5/trunk/arch/arch-gfortran.fcm	(revision 2270)
@@ -5,5 +5,5 @@
 %FPP_FLAGS           -P -traditional
 %FPP_DEF             NC_DOUBLE 
-%BASE_FFLAGS         -c -fdefault-real-8
+%BASE_FFLAGS         -c -fdefault-real-8 -frecursive
 %PROD_FFLAGS         -O3
 %DEV_FFLAGS          -O
Index: /LMDZ5/trunk/arch/arch-gfortran_CICLAD.fcm
===================================================================
--- /LMDZ5/trunk/arch/arch-gfortran_CICLAD.fcm	(revision 2269)
+++ /LMDZ5/trunk/arch/arch-gfortran_CICLAD.fcm	(revision 2270)
@@ -5,5 +5,5 @@
 %FPP_FLAGS           -P -traditional
 %FPP_DEF             NC_DOUBLE 
-%BASE_FFLAGS         -c -fdefault-real-8 -fcray-pointer
+%BASE_FFLAGS         -c -fdefault-real-8 -fcray-pointer -frecursive
 %PROD_FFLAGS         -O3
 %DEV_FFLAGS          -O -Wall -fbounds-check
Index: /LMDZ5/trunk/libf/dyn3d/advtrac.F90
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/advtrac.F90	(revision 2269)
+++ /LMDZ5/trunk/libf/dyn3d/advtrac.F90	(revision 2270)
@@ -9,5 +9,5 @@
   !            M.A Filiberti (04/2002)
   !
-  USE infotrac, ONLY: nqtot, iadv
+  USE infotrac, ONLY: nqtot, iadv,nqperes,ok_iso_verif
   USE control_mod, ONLY: iapp_tracvl, day_step
 
@@ -223,5 +223,10 @@
      !     Appel des sous programmes d'advection
      !-----------------------------------------------------------
-     do iq=1,nqtot
+
+     if (ok_iso_verif) then
+           call check_isotopes_seq(q,1,ip1jmp1,'advtrac 162')
+     endif !if (ok_iso_verif) then
+
+     do iq=1,nqperes
         !        call clock(t_initial)
         if(iadv(iq) == 0) cycle 
@@ -230,6 +235,9 @@
         !   ----------------------------------------------------------------
         if(iadv(iq).eq.10) THEN
-           call vlsplt(q(1,1,iq),2.,massem,wg,pbarug,pbarvg,dtvr)
-
+           ! CRisi: on fait passer tout q pour avoir acces aux fils
+           
+           write(*,*) 'advtrac 239: iq,q(1721,19,:)=',iq,q(1721,19,:)     
+           call vlsplt(q,2.,massem,wg,pbarug,pbarvg,dtvr,iq)
+           
            !   ----------------------------------------------------------------
            !   Schema "pseudo amont" + test sur humidite specifique
@@ -238,6 +246,8 @@
         else if(iadv(iq).eq.14) then
            !
-           CALL vlspltqs( q(1,1,1), 2., massem, wg , &
-                pbarug,pbarvg,dtvr,p,pk,teta )
+           write(*,*) 'advtrac 248: iq,q(1721,19,:)=',iq,q(1721,19,:)
+           CALL vlspltqs( q, 2., massem, wg , &
+                pbarug,pbarvg,dtvr,p,pk,teta,iq)
+           
            !   ----------------------------------------------------------------
            !   Schema de Frederic Hourdin
@@ -388,4 +398,7 @@
      end DO
 
+     if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'advtrac 397')
+     endif !if (ok_iso_verif) then
 
      !------------------------------------------------------------------
Index: /LMDZ5/trunk/libf/dyn3d/caladvtrac.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/caladvtrac.F	(revision 2269)
+++ /LMDZ5/trunk/libf/dyn3d/caladvtrac.F	(revision 2270)
@@ -53,5 +53,8 @@
       if (planet_type.eq."earth") then
 C initialisation
-        dq(:,:,1:2)=q(:,:,1:2)
+! CRisi: il faut gérer tous les traceurs si on veut pouvoir faire des
+! isotopes
+!        dq(:,:,1:2)=q(:,:,1:2)
+        dq(:,:,1:nqtot)=q(:,:,1:nqtot)
        
 c  test des valeurs minmax
@@ -81,6 +84,6 @@
            ENDDO
           ENDDO
-          
-          CALL qminimum( q, 2, finmasse )
+
+          CALL qminimum( q, nqtot, finmasse )
 
           CALL SCOPY   ( ip1jmp1*llm, masse, 1, finmasse,       1 )
@@ -92,5 +95,5 @@
           dtvrtrac = iapp_tracvl * dtvr
 c
-           DO iq = 1 , 2
+           DO iq = 1 , nqtot
             DO l = 1 , llm
              DO ij = 1,ip1jmp1
@@ -105,5 +108,5 @@
         if (planet_type.eq."earth") then
 ! Earth-specific treatment for the first 2 tracers (water)
-          dq(:,:,1:2)=0.
+          dq(:,:,1:nqtot)=0.
         endif ! of if (planet_type.eq."earth")
       ENDIF ! of IF( iapptrac.EQ.iapp_tracvl )
Index: /LMDZ5/trunk/libf/dyn3d/check_isotopes.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/check_isotopes.F	(revision 2270)
+++ /LMDZ5/trunk/libf/dyn3d/check_isotopes.F	(revision 2270)
@@ -0,0 +1,195 @@
+        subroutine check_isotopes_seq(q,ip1jmp1,err_msg)
+        USE infotrac
+        implicit none
+
+#include "dimensions.h"
+
+        ! inputs
+        integer ip1jmp1
+        real q(ip1jmp1,llm,nqtot)
+        character*(*) err_msg ! message d''erreur à afficher
+
+        ! locals
+        integer ixt,phase,k,i,iq,iiso,izone,ieau,iqeau
+        real xtractot,xiiso
+        real borne
+        real qmin
+        real errmax ! erreur maximale en absolu.
+        real errmaxrel ! erreur maximale en relatif autorisée
+        real deltaDmax,deltaDmin
+        real ridicule
+        parameter (borne=1e19)
+        parameter (errmax=1e-8)
+        parameter (errmaxrel=1e-3)
+        parameter (qmin=1e-11)
+        parameter (deltaDmax=200.0,deltaDmin=-999.9)
+        parameter (ridicule=1e-12)
+        real deltaD
+
+        if (ok_isotopes) then
+
+        ! verifier que rien n'est NaN
+        do ixt=1,ntraciso
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+              DO i = 1,ip1jmp1
+                if ((q(i,k,iq).gt.-borne).and.
+     :            (q(i,k,iq).lt.borne)) then
+                else !if ((x(ixt,i,j).gt.-borne).and.
+                  write(*,*) 'erreur detectee par iso_verif_noNaN:'
+                  write(*,*) err_msg
+                  write(*,*) 'q,i,k,iq=',q(i,k,iq),i,k,iq
+                  write(*,*) 'borne=',borne
+                  stop
+                endif  !if ((x(ixt,i,j).gt.-borne).and.
+              enddo !DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo !do phase=1,nqo
+        enddo !do ixt=1,ntraciso
+
+        ! verifier que l'eau normale est OK
+        if (use_iso(1)) then
+          ixt=indnum_fn_num(1)
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+            DO i = 1,ip1jmp1  
+              if ((abs(q(i,k,phase)-q(i,k,iq)).gt.errmax).and.
+     :          (abs((q(i,k,phase)-q(i,k,iq))/
+     :           max(max(abs(q(i,k,phase)),abs(q(i,k,iq))),1e-18))
+     :           .gt.errmaxrel)) then
+                  write(*,*) 'erreur detectee par iso_verif_egalite:'
+                  write(*,*) err_msg
+                  write(*,*) 'ixt,phase=',ixt,phase
+                  write(*,*) 'q,iq,i,k=',q(i,k,iq),iq,i,k
+                  write(*,*) 'q(i,k,phase)=',q(i,k,phase)
+                  stop
+              endif !if ((abs(q(i,k,phase)-q(i,k,iq)).gt.errmax).and.
+              ! bidouille pour éviter divergence:
+              q(i,k,iq)= q(i,k,phase) 
+            enddo ! DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo ! do phase=1,nqo 
+        endif !if (use_iso(1)) then
+        
+        ! verifier que HDO est raisonable
+        if (use_iso(2)) then
+          ixt=indnum_fn_num(2)
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+            DO i = 1,ip1jmp1
+            if (q(i,k,iq).gt.qmin) then
+             deltaD=(q(i,k,iq)/q(i,k,phase)/tnat(2)-1)*1000
+             if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+                  write(*,*) 'erreur detectee par iso_verif_aberrant:'
+                  write(*,*) err_msg
+                  write(*,*) 'ixt,phase=',ixt,phase
+                  write(*,*) 'q,iq,i,k,=',q(i,k,iq),iq,i,k
+                  write(*,*) 'q=',q(i,k,:)
+                  write(*,*) 'deltaD=',deltaD
+                  stop
+             endif !if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+            endif !if (q(i,k,iq).gt.qmin) then
+            enddo !DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo ! do phase=1,nqo 
+        endif !if (use_iso(2)) then
+
+        ! verifier que O18 est raisonable
+        if (use_iso(3)) then
+          ixt=indnum_fn_num(3)
+          do phase=1,nqo
+            iq=iqiso(ixt,phase)
+            do k=1,llm
+            DO i = 1,ip1jmp1
+            if (q(i,k,iq).gt.qmin) then
+             deltaD=(q(i,k,iq)/q(i,k,phase)/tnat(3)-1)*1000
+             if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+                  write(*,*) 'erreur detectee iso_verif_aberrant O18:'
+                  write(*,*) err_msg
+                  write(*,*) 'ixt,phase=',ixt,phase
+                  write(*,*) 'q,iq,i,k,=',q(i,k,phase),iq,i,k
+                  write(*,*) 'xt=',q(i,k,:)
+                  write(*,*) 'deltaO18=',deltaD
+                  stop
+             endif !if ((deltaD.gt.deltaDmax).or.(deltaD.lt.deltaDmin)) then
+            endif !if (q(i,k,iq).gt.qmin) then
+            enddo !DO i = 1,ip1jmp1
+            enddo !do k=1,llm
+          enddo ! do phase=1,nqo 
+        endif !if (use_iso(2)) then
+
+
+        if (ok_isotrac) then
+
+          if (use_iso(2).and.use_iso(1)) then
+            do izone=1,ntraceurs_zone
+             ixt=index_trac(izone,indnum_fn_num(2))
+             ieau=index_trac(izone,indnum_fn_num(1))
+             do phase=1,nqo
+               iq=iqiso(ixt,phase)
+               iqeau=iqiso(ieau,phase)
+               do k=1,llm
+                DO i = 1,ip1jmp1
+                if (q(i,k,iq).gt.qmin) then
+                 deltaD=(q(i,k,iq)/q(i,k,iqeau)/tnat(2)-1)*1000
+                 if ((deltaD.gt.deltaDmax).or.
+     &                   (deltaD.lt.deltaDmin)) then
+                  write(*,*) 'erreur dans iso_verif_aberrant trac:'
+                  write(*,*) err_msg
+                  write(*,*) 'izone,phase=',izone,phase
+                  write(*,*) 'ixt,ieau=',ixt,ieau
+                  write(*,*) 'q,iq,i,k,=',q(i,k,iq),iq,i,k
+                  write(*,*) 'deltaD=',deltaD
+                  stop
+                 endif !if ((deltaD.gt.deltaDmax).or.
+                endif !if (q(i,k,iq).gt.qmin) then
+                enddo !DO i = 1,ip1jmp1
+                enddo  ! do k=1,llm
+              enddo ! do phase=1,nqo    
+            enddo !do izone=1,ntraceurs_zone
+          endif !if (use_iso(2).and.use_iso(1)) then
+
+          do iiso=1,niso
+           do phase=1,nqo
+              iq=iqiso(iiso,phase)
+              do k=1,llm
+                DO i = 1,ip1jmp1
+                   xtractot=0.0
+                   xiiso=q(i,k,iq)
+                   do izone=1,ntraceurs_zone
+                      iq=iqiso(index_trac(izone,iiso),phase)
+                      xtractot=xtractot+ q(i,k,iq)
+                   enddo !do izone=1,ntraceurs_zone
+                   if ((abs(xtractot-xiiso).gt.errmax).and.
+     :                  (abs(xtractot-xiiso)/
+     :                  max(max(abs(xtractot),abs(xiiso)),1e-18)
+     :                  .gt.errmaxrel)) then
+                  write(*,*) 'erreur detectee par iso_verif_traceurs:'
+                  write(*,*) err_msg
+                  write(*,*) 'iiso,phase=',iiso,phase
+                  write(*,*) 'i,k,=',i,k
+                  write(*,*) 'q(i,k,:)=',q(i,k,:)
+                  stop
+                 endif !if ((abs(q(i,k,phase)-q(i,k,iq)).gt.errmax).and.
+                  
+                 ! bidouille pour éviter divergence:
+                 if (abs(xtractot).gt.ridicule) then
+                   do izone=1,ntraceurs_zone
+                     ixt=index_trac(izone,iiso) 
+                     q(i,k,iq)=q(i,k,iq)/xtractot*xiiso
+                   enddo !do izone=1,ntraceurs_zone                
+                  endif !if ((abs(xtractot).gt.ridicule) then
+                enddo !DO i = 1,ip1jmp1
+              enddo !do k=1,llm
+           enddo !do phase=1,nqo
+          enddo !do iiso=1,niso
+
+        endif !if (ok_isotrac) then
+
+        endif ! if (ok_isotopes)
+        
+        end
+
Index: /LMDZ5/trunk/libf/dyn3d/dynetat0.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/dynetat0.F	(revision 2269)
+++ /LMDZ5/trunk/libf/dyn3d/dynetat0.F	(revision 2270)
@@ -297,4 +297,19 @@
            write(lunout,*)"          Il est donc initialise a zero"
            q(:,:,:,iq)=0.
+
+           ! CRisi: pour les isotopes, on peut faire init théorique
+           ! distill de Rayleigh très simplifiée
+           if (ok_isotopes) then
+              if ((iso_num(iq).gt.0).and.(zone_num(iq).eq.0)) then
+                q(:,:,:,iq)=q(:,:,:,iqpere(iq))                         
+     &                   *tnat(iso_num(iq))                             
+     &                   *(q(:,:,:,iqpere(iq))/30.e-3)                  
+     &                   **(alpha_ideal(iso_num(iq))-1)
+              endif
+              if ((iso_num(iq).gt.0).and.(zone_num(iq).eq.1)) then
+                  q(:,:,:,iq)=q(:,:,:,iqiso(iso_indnum(iq),
+     &                   phase_num(iq)))
+              endif  
+           endif !if (ok_isotopes) then 
         ELSE
            ierr = NF90_GET_VAR(nid, nvarid, q(:,:,:,iq))
Index: /LMDZ5/trunk/libf/dyn3d/iniacademic.F90
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/iniacademic.F90	(revision 2269)
+++ /LMDZ5/trunk/libf/dyn3d/iniacademic.F90	(revision 2270)
@@ -5,5 +5,5 @@
 
   USE filtreg_mod, ONLY: inifilr
-  USE infotrac, ONLY : nqtot
+  USE infotrac
   USE control_mod, ONLY: day_step,planet_type
 #ifdef CPP_IOIPSL
@@ -262,8 +262,27 @@
               if (i == 2) q(:,:,i)=1.e-15
               if (i.gt.2) q(:,:,i)=0.
+
+              ! CRisi: init des isotopes
+              ! distill de Rayleigh très simplifiée
+              if (ok_isotopes) then
+                if ((iso_num(i).gt.0).and.(zone_num(i).eq.0)) then          
+                   q(:,:,i)=q(:,:,iqpere(i))             &
+      &                  *tnat(iso_num(i))               &
+      &                  *(q(:,:,iqpere(i))/30.e-3)      &
+      &                  **(alpha_ideal(iso_num(i))-1)
+                endif                
+                if ((iso_num(i).gt.0).and.(zone_num(i).eq.1)) then
+                  q(:,:,i)=q(:,:,iqiso(iso_indnum(i),phase_num(i)))
+                endif
+              endif !if (ok_isotopes) then
+
            enddo
         else
            q(:,:,:)=0
         endif ! of if (planet_type=="earth")
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,1,ip1jmp1,'iniacademic_loc')
+        endif !if (ok_iso_verif) then
 
         ! add random perturbation to temperature
Index: /LMDZ5/trunk/libf/dyn3d/leapfrog.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/leapfrog.F	(revision 2269)
+++ /LMDZ5/trunk/libf/dyn3d/leapfrog.F	(revision 2270)
@@ -11,5 +11,5 @@
       use IOIPSL
 #endif
-      USE infotrac, ONLY: nqtot
+      USE infotrac, ONLY: nqtot,ok_iso_verif
       USE guide_mod, ONLY : guide_main
       USE write_field, ONLY: writefield
@@ -235,4 +235,7 @@
       jH_cur = jH_cur - int(jH_cur)
 
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 321')
+        endif !if (ok_iso_verif) then
 
 #ifdef CPP_IOIPSL
@@ -265,4 +268,8 @@
 !      CALL SCOPY   ( ijp1llm,   masse, 1, finvmaold,     1 )
 !      CALL filtreg ( finvmaold ,jjp1, llm, -2,2, .TRUE., 1 )
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 400')
+        endif !if (ok_iso_verif) then
 
    2  CONTINUE ! Matsuno backward or leapfrog step begins here
@@ -305,4 +312,9 @@
       endif
 
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 589')
+        endif !if (ok_iso_verif) then
+
 c-----------------------------------------------------------------------
 c   calcul des tendances dynamiques:
@@ -321,4 +333,9 @@
 c   calcul des tendances advection des traceurs (dont l'humidite)
 c   -------------------------------------------------------------
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,
+     &           'leapfrog 686: avant caladvtrac')
+        endif !if (ok_iso_verif) then
 
       IF( forward. OR . leapf )  THEN
@@ -327,4 +344,5 @@
      *        p, masse, dq,  teta,
      .        flxw, pk)
+
          
          IF (offline) THEN
@@ -346,9 +364,17 @@
 c   ----------------------------------
 
-
-       CALL integrd ( 2,vcovm1,ucovm1,tetam1,psm1,massem1 ,
+        if (ok_iso_verif) then
+           write(*,*) 'leapfrog 720' 
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 756')
+        endif !if (ok_iso_verif) then
+        
+       CALL integrd ( nqtot,vcovm1,ucovm1,tetam1,psm1,massem1 ,
      $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis )
 !     $              finvmaold                                    )
 
+       if (ok_iso_verif) then
+          write(*,*) 'leapfrog 724'
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 762')
+        endif !if (ok_iso_verif) then
 
 c .P.Le Van (26/04/94  ajout de  finvpold dans l'appel d'integrd)
@@ -516,4 +542,7 @@
         CALL massdair(p,masse)
 
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1196')
+        endif !if (ok_iso_verif) then
 
 c-----------------------------------------------------------------------
@@ -600,4 +629,8 @@
 c   preparation du pas d'integration suivant  ......
 
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1509')
+        endif !if (ok_iso_verif) then
+
       IF ( .NOT.purmats ) THEN
 c       ........................................................
@@ -657,4 +690,8 @@
             ENDIF ! of IF((MOD(itau,iperiod).EQ.0).OR.(itau.EQ.itaufin))
 
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1584')
+        endif !if (ok_iso_verif) then
+
 c-----------------------------------------------------------------------
 c   ecriture de la bande histoire:
@@ -735,4 +772,8 @@
       ELSE ! of IF (.not.purmats)
 
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1664')
+        endif !if (ok_iso_verif) then
+
 c       ........................................................
 c       ..............       schema  matsuno        ...............
@@ -757,4 +798,8 @@
 
             ELSE ! of IF(forward) i.e. backward step
+ 
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'leapfrog 1698')
+        endif !if (ok_iso_verif) then  
 
               IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
Index: /LMDZ5/trunk/libf/dyn3d/qminimum.F
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/qminimum.F	(revision 2269)
+++ /LMDZ5/trunk/libf/dyn3d/qminimum.F	(revision 2270)
@@ -2,6 +2,7 @@
 ! $Header$
 !
-      SUBROUTINE qminimum( q,nq,deltap )
+      SUBROUTINE qminimum( q,nqtot,deltap )
 
+      USE infotrac, ONLY: ok_isotopes,ntraciso,iqiso,ok_iso_verif
       IMPLICIT none
 c
@@ -13,6 +14,6 @@
 #include "comvert.h"
 c
-      INTEGER nq
-      REAL q(ip1jmp1,llm,nq), deltap(ip1jmp1,llm)
+      INTEGER nqtot
+      REAL q(ip1jmp1,llm,nqtot), deltap(ip1jmp1,llm)
 c
       INTEGER iq_vap, iq_liq
@@ -30,4 +31,7 @@
       INTEGER i, k, iq
       REAL zx_defau, zx_abc, zx_pump(ip1jmp1), pompe
+
+      real zx_defau_diag(ip1jmp1,llm,2) 
+      real q_follow(ip1jmp1,llm,2)
 c
       REAL SSUM
@@ -36,4 +40,8 @@
       SAVE imprim
       DATA imprim /0/
+      !INTEGER ijb,ije
+      !INTEGER Index_pump(ij_end-ij_begin+1)
+      !INTEGER nb_pump
+      INTEGER ixt
 c
 c Quand l'eau liquide est trop petite (ou negative), on prend
@@ -41,7 +49,20 @@
 c (sans changer la temperature !)
 c
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'qminimum 52')   
+        endif !if (ok_iso_verif) then     
+
+      zx_defau_diag(:,:,:)=0.0
+      q_follow(:,:,:)=q(:,:,:)  
       DO 1000 k = 1, llm
         DO 1040 i = 1, ip1jmp1
           if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
+
+              if (ok_isotopes) then
+                 zx_defau_diag(i,k,iq_liq)=AMAX1
+     :               ( seuil_liq - q(i,k,iq_liq), 0.0 )
+              endif !if (ok_isotopes) then
+
              q(i,k,iq_vap) = q(i,k,iq_vap) + q(i,k,iq_liq) - seuil_liq
              q(i,k,iq_liq) = seuil_liq
@@ -59,4 +80,9 @@
         DO i = 1, ip1jmp1
           if ( seuil_vap - q(i,k,iq) .gt. 0.d0 ) then
+
+            if (ok_isotopes) then
+              zx_defau_diag(i,k,iq)=AMAX1( seuil_vap - q(i,k,iq), 0.0 )
+            endif !if (ok_isotopes) then
+
             q(i,k-1,iq) =  q(i,k-1,iq) - ( seuil_vap - q(i,k,iq) ) *
      &                     deltap(i,k) / deltap(i,k-1)
@@ -83,4 +109,83 @@
          ENDDO
       ENDIF
+
+      write(*,*) 'qminimum 128'
+      if (ok_isotopes) then
+      ! CRisi: traiter de même les traceurs d'eau
+      ! Mais il faut les prendre à l'envers pour essayer de conserver la
+      ! masse.
+      ! 1) pompage dans le sol  
+      ! On suppose que ce pompage se fait sans isotopes -> on ne modifie
+      ! rien ici et on croise les doigts pour que ça ne soit pas trop
+      ! génant
+      DO i = 1,ip1jmp1
+        if (zx_pump(i).gt.0.0) then
+          q_follow(i,1,iq_vap)=q_follow(i,1,iq_vap)+zx_pump(i)
+        endif !if (zx_pump(i).gt.0.0) then
+      enddo !DO i = 1,ip1jmp1
+
+      ! 2) transfert de vap vers les couches plus hautes
+      !write(*,*) 'qminimum 139'
+      do k=2,llm
+        DO i = 1,ip1jmp1
+          if (zx_defau_diag(i,k,iq_vap).gt.0.0) then             
+              ! on ajoute la vapeur en k              
+              do ixt=1,ntraciso
+               q(i,k,iqiso(ixt,iq_vap))=q(i,k,iqiso(ixt,iq_vap))
+     :              +zx_defau_diag(i,k,iq_vap)
+     :              *q(i,k-1,iqiso(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
+                
+              ! et on la retranche en k-1
+               q(i,k-1,iqiso(ixt,iq_vap))=q(i,k-1,iqiso(ixt,iq_vap))
+     :              -zx_defau_diag(i,k,iq_vap)
+     :              *deltap(i,k)/deltap(i,k-1)
+     :              *q(i,k-1,iqiso(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
+
+              enddo !do ixt=1,niso
+              q_follow(i,k,iq_vap)=   q_follow(i,k,iq_vap)
+     :               +zx_defau_diag(i,k,iq_vap)
+              q_follow(i,k-1,iq_vap)=   q_follow(i,k-1,iq_vap)
+     :               -zx_defau_diag(i,k,iq_vap)
+     :              *deltap(i,k)/deltap(i,k-1)
+          endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
+        enddo !DO i = 1, ip1jmp1        
+       enddo !do k=2,llm
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'qminimum 168')
+        endif !if (ok_iso_verif) then
+        
+      
+        ! 3) transfert d'eau de la vapeur au liquide
+        !write(*,*) 'qminimum 164'
+        do k=1,llm
+        DO i = 1,ip1jmp1
+          if (zx_defau_diag(i,k,iq_liq).gt.0.0) then
+
+              ! on ajoute eau liquide en k en k              
+              do ixt=1,ntraciso
+               q(i,k,iqiso(ixt,iq_liq))=q(i,k,iqiso(ixt,iq_liq))
+     :              +zx_defau_diag(i,k,iq_liq)
+     :              *q(i,k,iqiso(ixt,iq_vap))/q_follow(i,k,iq_vap)
+              ! et on la retranche à la vapeur en k
+               q(i,k,iqiso(ixt,iq_vap))=q(i,k,iqiso(ixt,iq_vap))
+     :              -zx_defau_diag(i,k,iq_liq)
+     :              *q(i,k,iqiso(ixt,iq_vap))/q_follow(i,k,iq_vap)   
+              enddo !do ixt=1,niso
+              q_follow(i,k,iq_liq)=   q_follow(i,k,iq_liq)
+     :               +zx_defau_diag(i,k,iq_liq)
+              q_follow(i,k,iq_vap)=   q_follow(i,k,iq_vap)
+     :               -zx_defau_diag(i,k,iq_liq)
+          endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
+        enddo !DO i = 1, ip1jmp1
+       enddo !do k=2,llm  
+
+        if (ok_iso_verif) then
+           call check_isotopes_seq(q,ip1jmp1,'qminimum 197')
+        endif !if (ok_iso_verif) then
+
+      endif !if (ok_isotopes) then
+      !write(*,*) 'qminimum 188'
+      
 c
       RETURN
